
#
# another test driver for the Account class
#
# author: David Mathias
#

from account import Account

def main():
    
    print('Creating accounts:\n')
    checking = Account('David', 50000)
    savings = Account('David', 1000000)
    money_market = Account('David', 50000)
    ira = savings
    brokerage = Account()
    
    # invoking __bool__
    print('invoking __bool__ with call:')
    print('   if checking:')
    if checking:
        print('checking is True\n')
        
    # invoking __bool__
    print('invoking __bool__ with call:')
    print('   if brokerage:')
    if brokerage:
        print('brokerage is True\n')
    else:
        print('brokerage is False\n')
        
    # invoking __lt__
    print('invoking __lt__ with call:')
    print('   if savings < checking:')
    if savings < checking:
        print('Transfer money to savings.\n')
    else:
        print('Balances are good.\n')

    # checking for equality
    # if __eq__ doesn't exist, this tests references for equality
    print('invoking __eq__ with call:')
    print('   if ira == savings:')    
    if ira == savings:
        print('They are equal because they refer to the same object.\n')
    
    
    print('invoking __eq__ with call:')
    print('   if money_market == checking:')    
    if money_market == checking:
        print('These are equal even though they dont refer to the same object.\n')

    # invoking __add__
    print('invoking __add__ with call:')
    print('   checking + savings')    
    print('')
    print('The total of your checking and savings accounts is: {}\n'.format(checking + savings))
    
    # this gives an error --- why?
    # print('The total of all your accounts is: {}\n'.format(checking + savings + money_market))
    
    # invoking __iadd__
    print('invoking __iadd__ with call:')
    print('   ira += checking')    
    ira += checking
    print(ira)
    print(savings)
    
    print('invoking __repr__ with calls:')
    print('   repr(ira) and repr(savings)')
    print(repr(ira))
    print(repr(savings))
    print('')
    
    print('invoking __iadd__ with call:')
    print('   brokerage += savings')    
    brokerage += savings
    print(brokerage)
    print(savings)
    print('invoking __repr__ with calls:')
    print('   repr(brokerage) and repr(savings)')
    print(repr(brokerage))
    print(repr(savings))
    print('')

    print('invoking __repr__ with call:')
    print('   new_checking = eval(repr(checking))')
    new_checking = eval(repr(checking))
    print(new_checking)
    print('')
    
    # invoking __call__
    print('invoking __call__ with call:')
    print('   savings(1000)')    
    savings(1000)
    print(savings)
    
if __name__ == '__main__':
    main()
